//+------------------------------------------------------------------+
//|                                            TwitterSignalizer.mq4 |
//|                         Copyright  2011, BJF Trading Group inc. |
//|                                      http://www.iticsoftware.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, BJF Trading Group inc."
#property link      "http://www.iticsoftware.com "
#import "post_to_twitter.dll"
int    SendMsgToTwitter(string KeyFilesPath,string mes);
#import

extern int TimeIntervalForStatusUpdate=10;
extern int DayToTwittProfit=5;
extern int HourToTwittProfit=18;
extern int MinuteToTwittProfit=00;
int orders_total=0;
int history_orders_total=0;
string files_path;
int last_check_time;
int last_profit_date;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  files_path=TerminalPath()+"\\experts\\files\\";
  last_check_time=TimeCurrent();  
  last_profit_date=0;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  CheckOrders();
  ShowProfit(); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
string OrderTypeToStr(int type)
{
switch (type)
{
  case OP_BUY:return ("buy");
  case OP_SELL:return ("sell");
  case OP_BUYLIMIT:return ("buylimit");
  case OP_BUYSTOP:return ("buystop");
  case OP_SELLLIMIT:return ("selllimit");
  case OP_SELLSTOP:return ("sellstop");
}
}
//+------------------------------------------------------------------+
void NewOrder()
{
if (TimeCurrent()-OrderOpenTime()>TimeIntervalForStatusUpdate+10) return;
string Message=TimeToStr(OrderOpenTime())+":Order was opened:"+OrderTypeToStr(OrderType())+" "+
DoubleToStr(OrderLots(),2) + " " + OrderSymbol()+" at "+
DoubleToStr(OrderOpenPrice(),5);
SendMsgToTwitter(files_path,Message);
}
//+------------------------------------------------------------------+
void OrderIsClosed()
{
if (TimeCurrent()-OrderCloseTime()>TimeIntervalForStatusUpdate+10) return;
string Message=TimeToStr(OrderCloseTime())+":Order "+OrderTypeToStr(OrderType())+
" "+DoubleToStr(OrderLots(),2)+" "+OrderSymbol()+" at "+DoubleToStr(OrderOpenPrice(),5)+
" was closed at "+DoubleToStr(OrderClosePrice(),5)+" with profit:"+DoubleToStr(OrderProfit(),2); 
SendMsgToTwitter(files_path,Message);
}
//+------------------------------------------------------------------+
void CheckOrders()
{
if (TimeCurrent()-last_check_time<TimeIntervalForStatusUpdate) return;
int i;
if (OrdersTotal()>orders_total)
{
for (i=orders_total;i<OrdersTotal();i++)
 {
 OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
 NewOrder();
 }
}

if (OrdersHistoryTotal()>history_orders_total)
{
for (i=history_orders_total;i<OrdersHistoryTotal();i++)
 {
 OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
 OrderIsClosed();
 }
}

orders_total=OrdersTotal();
history_orders_total=OrdersHistoryTotal();
last_check_time=TimeCurrent();
}
//+------------------------------------------------------------------+
void ShowProfit()
{
if (DayOfWeek()==DayToTwittProfit&&Hour()==HourToTwittProfit&&Minute()==MinuteToTwittProfit)
{
 if (TimeCurrent()-last_profit_date<61) return;
 SendMsgToTwitter(files_path,"Current account profit:"+DoubleToStr(AccountProfit(),2)+" "+AccountCurrency());
 last_profit_date=TimeCurrent();
}
 
}
//+------------------------------------------------------------------+